<template>
  <v-app id="inspire">
    <v-app-bar
      :clipped-left="$vuetify.breakpoint.lgAndUp"
      app
      color="primary"
      dark
    >
      <v-toolbar-title style="width: 350px">
        <a href="/" class="white--text" style="text-decoration: none"><v-icon>mdi-truck</v-icon>&nbsp;Barom</a>
      </v-toolbar-title>
      <v-text-field
        flat
        solo-inverted
        hide-details
        label="Введите что-нибудь и откройте консоль"
        v-model="searchField"
        prepend-inner-icon="mdi-magnify"
        class="hidden-sm-and-down ml-12"
      />
      <v-spacer />
      <v-btn  outlined depressed>
        <span v-if="isLoggedIn"><a class='white--text pr-3' @click="logout">Выйти</a></span>
        <span v-else><router-link class="white--text pr-3" to="/login">Войти</router-link></span>
      </v-btn>
      <v-btn  v-if="!isLoggedIn" outlined depressed>
        <router-link class="white--text " to="/registration">Зарегистрироваться</router-link>
      </v-btn>
      <v-btn icon>
        <v-icon>mdi-account-circle</v-icon>
      </v-btn>
      <v-btn v-on="on" icon>
        <v-badge
          content="2"
          value="2"
          color="green"
          overlap
        >
          <v-icon>mdi-bell</v-icon>
        </v-badge>
      </v-btn>
      <v-btn v-on="on" href="/cart" icon>
        <v-badge
          :content="[cartTotalLength ? cartTotalLength : 0]"
          :value="10"
          color="green"
          overlap
        >
          <v-icon>mdi-cart</v-icon>
        </v-badge>
      </v-btn>
    </v-app-bar>
    <v-content>
      <v-bottom-navigation
        :value="activeBtn"
        color="primary"
        horizontal
      >
        <a href="/" class="v-btn">
          <span>Главная</span>
        </a>
        <a href="/services" class="v-btn">
          <span>Услуги</span>
        </a>
        <v-btn href="/blog">
          <span>Блог</span>
        </v-btn>
      </v-bottom-navigation>
    </v-content>
    <v-content>
      <div class="text-center pb-12">
        <div :class="{'lds-ring': $store.state.isLoading}">
          <div></div>
          <div></div>
          <div></div>
          <div></div>
        </div>
      </div>
    </v-content>
    <router-view />
    <v-footer
      :padless="true"
    >
      <v-card
        flat
        tile
        width="100%"
        class="secondary white--text text-center"
      >
        <v-card-text>
          <v-btn
            class="mx-4 white--text"
            icon
          >
            <v-icon size="24px">mdi-home</v-icon>
          </v-btn>
          <v-btn
            class="mx-4 white--text"
            icon
          >
            <v-icon size="24px">mdi-email</v-icon>
          </v-btn>
          <v-btn
            class="mx-4 white--text"
            icon
          >
            <v-icon size="24px">mdi-calendar</v-icon>
          </v-btn>
          <v-btn
            class="mx-4 white--text"
            icon
          >
            <v-icon size="24px">mdi-delete</v-icon>
          </v-btn>
        </v-card-text>
        <v-card-text class="white--text pt-0">
          Тренировочный сайт, в основе которого находится подработка моего друга Рустема.
          Написан на Django и VueJS. Дизайн сайта взят отсюда:
          https://github.com/18chetanpatel/shipit
        </v-card-text>
        <v-divider></v-divider>
        <v-card-text class="white--text">
          {{ new Date().getFullYear() }} — <strong>Barom</strong>
        </v-card-text>
      </v-card>
    </v-footer>
  </v-app>
</template>

<script>
import axios from 'axios'
import {debounce} from "lodash";

export default {
  data() {
    return {
      searchField: '',
      searchedServices: [],
      activeBtn: 1,
      num: 5,
      cart: {
        items: []
      },
      token: ''
    }
  },
  watch: {
    searchField: function () {
      if (this.searchField.length >= 3) {
        this.searchDebounced()
      }
    }
  },
  beforeCreate() {
    this.$store.commit('initializeStore')
    const token = this.$store.getters.getToken
    if (token) {
      axios.defaults.headers.common['Authorization'] = 'JWT ' + token
    } else {
      axios.defaults.headers.common['Authorization'] = ''
    }
  },
  created() {
    this.searchDebounced = debounce(this.search, 1000)
  },
  mounted() {
    this.cart = this.$store.state.cart.cart
  },
  computed: {
    isLoggedIn() {
      return this.$store.getters.isLoggedIn
    },
    cartTotalLength() {
      return this.cart.items.length
    },
  },
  methods: {
    logout() {
      this.$store.dispatch('logout')
        .then(() => {
          this.$router.push('/login')
        })
    },
    async search() {
      let request = { query : this.searchField }
      await axios({
        data: request,
        method: 'post',
        url: `${this.$store.getters.getServerUrl}api/v1/reviews/services/search/`
      })
        .then(resp => {
          this.searchedServices = resp.data
          console.log(resp)
          console.log(resp.data)
        })
        .catch(e => console.log(e))
    },
  }
}
</script>

<style scoped>
.white--text {
  text-decoration: none;
}

.lds-ring {
  display: inline-block;
  position: relative;
  width: 80px;
  height: 80px;
}

.lds-ring div {
  box-sizing: border-box;
  display: block;
  position: absolute;
  width: 64px;
  height: 64px;
  margin: 8px;
  border-radius: 50%;
  animation: lds-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;
  border-color: #2d3753 transparent transparent transparent;
}

.lds-ring div:nth-child(1) {
  animation-delay: -0.45s;
}

.lds-ring div:nth-child(2) {
  animation-delay: -0.3s;
}

.lds-ring div:nth-child(3) {
  animation-delay: -0.15s;
}

@keyframes lds-ring {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}
</style>
